/*
	Radu
	Image 100
	
	O(n) for k>100 and O(k^3) with matrix exponention for k<=100

*/


#include<cstdio>
#include<iostream>

using namespace std;

const int W=33, Q=10000007;

int s,n,k,f;

long long good, bad;

const int R=1000000007;


long long powbad[Q];

long long no_variants[Q];

void arranj(long long &x)
{
	while(x<0)
		x+=R;
}


//O(n) solver
long long my_content()
{
	no_variants[(0)]=1;

	long long myprice=0;

	for(int i=1; i<=n; i++)
	{
		myprice*=bad;
		myprice+=no_variants[(i-1)];
		myprice%=R;

		if(i-k>0)
		{
			myprice-=(no_variants[(i-k-1) ]*powbad[k])%R;
			arranj(myprice);
		}

		no_variants[(i)]=myprice*good;
		no_variants[(i)]%=R;
	
	}
	myprice*=bad;
	myprice+=no_variants[(n)];
	myprice%=R;
	myprice-=(no_variants[(n-k)]*powbad[k])%R;
	arranj(myprice);

	return myprice;
}




//combination precalculation

long long comb(int T, int X)
{
	long long factS=1;

	for(int i=1; i<=T; i++)
	{
		factS*=i;
	}

	for(int i=1; i<=X; i++)
		factS/=i;

	for(int i=1; i<=T-X; i++)
		factS/=i;

	return factS;

}

void precalc_combinari()
{
	for(int i=0; i<f; i++)
	{
		bad+=comb(s,i);
	}
	for(int i=f; i<=s; i++)
	{
		good+=comb(s,i);
	}
	bad%=R;
	good%=R;

	powbad[0]=1;

	for(int i=1; i<=k+1; i++)
	{
		powbad[i]=powbad[i-1]*bad;
		powbad[i]%=R;
	}
}

//matrix structure
struct matrice
{
	long long v[107][107];

	matrice()
	{
		for(int i=1; i<=k; i++)
		{
			for(int j=1; j<=k; j++)
			{
				v[i][j]=0;
			}
		}
	}

	void operator =(const matrice &alt)
	{
		for(int i=1; i<=k; i++)
		{
			for(int j=1; j<=k; j++)
			{
				v[i][j]=alt.v[i][j];
			}
		}
	}
} my, I, O;

//matrix multiplication

matrice operator *(const matrice &a, const matrice &b)
{
	matrice rez=O;

	for(int i=1; i<=k; i++)
	{
		for(int j=1; j<=k; j++)
		{
			for(int g=1; g<=k; g++)
			{
				rez.v[i][j]+=(a.v[i][g]*b.v[g][j])%R;
			}

			rez.v[i][j]%=R;
		}
	}
	return rez;
}

long long make_matrix()
{
	long long act=good;

	for(int i=1; i<=k; i++)
	{
		my.v[1][i]=act;
		act*=bad;
		act%=R;
	}

	for(int i=2; i<=k; i++)
	{
		my.v[i][i-1]=1;
	}

	for(int i=1; i<=k; i++)
	{
		I.v[i][i]=1;
	}


	int pow=n-k;

	matrice rez=I;

	while(pow)
	{
		if(pow&1)
		{
			rez=rez*my;
		}

		my=my*my;
		pow/=2;
	}

	long long rezultat=0;

	for(int i=1; i<=k; i++)
	{
		long long aux=good;
		long long myrz=0;
		for(int j=k; j>0; j--)
		{
			myrz+=rez.v[i][j]*aux;
			aux*=(good+bad);
			aux%=R;
			myrz%=R;
		}
		myrz*=powbad[i-1];
		myrz%=R;
		rezultat+=myrz;
		rezultat%=R;
	}

	return rezultat;

}





int main()
{
	freopen("image.in","r",stdin);
	freopen("image.out","w",stdout);

	scanf("%d%d%d%d",&s,&n,&k,&f);
	precalc_combinari();

	long long rez;

	
	if(k>100)
		rez=my_content();
	else
		rez=make_matrix();

	printf("%lld\n",rez);
	return 0;
}
